#ifndef _GLOBALS_H
#define _GLOBALS_H

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

#define MAX_NAME_SIZE 100
#define MAX_NUM_FRAME_PER_PACKET 10
#define SAMPLE_PER_FRAME 80
#define INIT_RELATIVE_DELAY 30
#define INIT_FRAME_PER_PACKET 3

class TGlobals
{
 public:

  TGlobals() {
    numFramePerPacket = INIT_FRAME_PER_PACKET;
    isExp = false;
    isPrevOpt = false;
    isSpike = false;
    isMaxDelay = false;
    fecFlag = false;
    midSpurtFlag = false;
    lineSkip = 0;

    strcpy(inputFile, "3001_tape1a_1min.pcm");
    strcpy(outputFile, "fileout.pcm");
    strcpy(traceFile, "nd_input.log");
    strcpy(logFile, "log.out");
    strcpy(lossFile,"loss.pcm");
    strcpy(vadFile, "vad.log");
  };

  ~TGlobals() {
    fclose(fIn);
    fclose(fOut);
    fclose(fTrace);
    fclose(fLog);
    fclose(fLoss);
    fclose(fVad);
  };

  void handleExit(const char *msg) {
    printf("%s\n", msg);

    fclose(fIn);
    fclose(fOut);
    fclose(fTrace);
    fclose(fLog);
    fclose(fLoss);
    fclose(fVad);

    exit(1);
  }; 
  
  char inputFile[MAX_NAME_SIZE];
  char outputFile[MAX_NAME_SIZE];
  char traceFile[MAX_NAME_SIZE];
  char logFile[MAX_NAME_SIZE];
  char lossFile[MAX_NAME_SIZE];
  char vadFile[MAX_NAME_SIZE];

  int numFramePerPacket;
  int lineSkip;
  bool isExp;
  bool isPrevOpt;
  bool isSpike;
  bool isMaxDelay;
  bool fecFlag;
  bool midSpurtFlag;
  
  FILE *fIn;
  FILE *fOut;
  FILE *fTrace;
  FILE *fLog;
  FILE *fLoss;
  FILE *fVad;
};

#endif
