#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "g729_encoder.h"
#include "Globals.h"
#include "Receiver.h"
#include "FECReceiver.h"

void usage()
{
  printf("Usage: trans [-x exp-avg|prev-opt|spike|max-delay] -f -m -i <Input File> -o <Output File> -p <Num Frame Per Packet> -t <network trace file> -s <# of lines>");
}

int main(int argc, char *argv[])
{
  char ch;
  TGlobals g;

  while (EOF != (ch=getopt(argc, argv, "x:i:o:fmp:t:s:")))
  {
    switch(ch)
    {
      case 'x':
        if (!strcmp(optarg, "exp-avg"))
        {
          g.isExp = true;
        } else if (!strcmp(optarg, "prev-opt")) {
          g.isPrevOpt = true;
        } else if (!strcmp(optarg, "spike")) {
          g.isSpike = true;
        } else if (!strcmp(optarg, "max-delay")) {
          g.isMaxDelay = true;
        } else {
          usage();
          exit(0);
        }
        break;

      case 'i':
        strcpy(g.inputFile, optarg);
        break;

      case 'o':
        strcpy(g.outputFile, optarg);
        break;

      case 'f':
        g.fecFlag = true;
        break;
 
      case 'm':
        g.midSpurtFlag = true;
        break;

      case 'p':
        g.numFramePerPacket = atoi(optarg);
        break;

      case 't':
        strcpy(g.traceFile, optarg);
        break;

      case 's':
        g.lineSkip = atoi(optarg);
        break;

      default:
        usage();
        exit(0);
        break;
    }
  }

  if (!g.fecFlag)
  {
    TReceiver receiver(&g);
    receiver.generate();
  } else {
    TFECReceiver receiver(&g);
    receiver.generate();
  }
}
